#ifndef EFL_VG_ROOT_NODE_EO_HH
#define EFL_VG_ROOT_NODE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_vg.eo.h"
#include "efl_vg_container.eo.h"
#include "efl_vg_root_node.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_gfx.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_vg.eo.hh"
#include "efl_vg_container.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace vg { 
struct Root_Node;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::vg::Root_Node> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace vg { 
struct Root_Node {
   static Eo_Class const* _eo_class()
   {
      return EFL_VG_ROOT_NODE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::vg::Root_Node() const;
   operator ::efl::vg::Root_Node&();
   operator ::efl::vg::Root_Node const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Root_Node,  ::efl::Gfx,  ::efl::VG,  ::efl::gfx::Stack,  ::efl::vg::Container,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Root_Node const ,  ::efl::Gfx const ,  ::efl::VG const ,  ::efl::gfx::Stack const ,  ::efl::vg::Container const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace vg { 
struct Root_Node : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::VG)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::vg::Container)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Root_Node( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Root_Node(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Root_Node(Root_Node const& other) = default;
   Root_Node(Root_Node&& other) = default;
   Root_Node& operator=(Root_Node const& other) = default;
   Root_Node& operator=(Root_Node&& other) = default;
   Root_Node()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Root_Node( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Root_Node(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EFL_VG_ROOT_NODE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Root_Node,  ::efl::Gfx,  ::efl::VG,  ::efl::gfx::Stack,  ::efl::vg::Container,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Root_Node const ,  ::efl::Gfx const ,  ::efl::VG const ,  ::efl::gfx::Stack const ,  ::efl::vg::Container const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Root_Node) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Root_Node>::value, "");
} } 
#include "efl_vg_root_node.eo.impl.hh"
#endif
